package cn.efunbox.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.view.json.MappingJacksonJsonView;

import cn.efunbox.model.Click;
import cn.efunbox.service.IClickService;

@SuppressWarnings("deprecation")
@Controller
@RequestMapping("/click")
public class ClickController {
	
	@Autowired  
	private  HttpServletRequest request;
	
    private IClickService clickService;
    
    public IClickService getRecommendService() {
        return clickService;
    }

    @Autowired
    public void setPersonService(IClickService clickService) {
        this.clickService = clickService;
    }

    @RequestMapping("/getAll")
    @ResponseBody
    public Map<String,Object> getAll(){
        List<Click> clicks = clickService.loadAll();
        Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("code", 200);
        map.put("rows", clicks);
        return map;
    }

    @RequestMapping("/search")
    @ResponseBody
    public Map<String,Object> searchRecommend(){
    	String ageStr = request.getParameter("age");
		String sexStr = request.getParameter("sex");
		String pageStr = request.getParameter("page");
		String sizeStr = request.getParameter("size");
		if(ageStr==null)
			ageStr = "5";
		if(sexStr==null)
			sexStr = "1";
		if(pageStr==null)
			pageStr = "1";
		if(sizeStr==null)
			sizeStr = "10";
		int age = Integer.valueOf(ageStr);
		int sex = Integer.valueOf(sexStr);
		int page = Integer.valueOf(pageStr);
		int size = Integer.valueOf(sizeStr);
		if(age<0 || age>20)
			age = 5;
		if(sex!=1 && sex!=2)
			sex = 1;
		if(page<1)
			page = 1;
		if(size<10)
			size = 10;
		
		Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("code", 200);
        map.put("rows", 1);
        return map;
    }
    
}