package cn.efunbox.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.view.json.MappingJacksonJsonView;

import cn.efunbox.model.Recommend;
import cn.efunbox.service.IRecommendService;

@SuppressWarnings("deprecation")
@Controller
@RequestMapping("/recommend")
public class RecommendController {
	
	@Autowired  
	private  HttpServletRequest request;
	
    private IRecommendService recmdService;
    
    public IRecommendService getRecommendService() {
        return recmdService;
    }

    @Autowired
    public void setPersonService(IRecommendService recmdService) {
        this.recmdService = recmdService;
    }
/*
    @RequestMapping("/showAll")
    public String getRecommend(Model model){
        List<Recommend> recmds = recmdService.loadAll();
        model.addAttribute("recmds", recmds);
        return "showRecmds";
    }
    
    @ResponseBody
    @RequestMapping("/getStr")
    public String getRecommendStr(){
        List<Recommend> recmds = recmdService.loadAll();
        return recmds.toString();
    }

    @RequestMapping("/getJson")
    @ResponseBody
    public Map<String,Object> getRecommendJson(){
        List<Recommend> recmds = recmdService.loadAll();
        Map<String, Object> map = new HashMap<String, Object>(3);
        map.put("code", 200);
        map.put("num", 3);
        map.put("recmds", recmds);
        return map;
    }
    

    @RequestMapping("/getJson2")
    @ResponseBody
    public ModelAndView getRecommendJson2(){
        List<Recommend> recmds = recmdService.loadAll();
        Map<String, Object> map = new HashMap<String, Object>(3);
        map.put("code", 200);
        map.put("num", 3);
        map.put("recmds", recmds);
        return new ModelAndView(new MappingJacksonJsonView(),map);
    }
*/
    @RequestMapping("/getAll")
    @ResponseBody
    public Map<String,Object> getRecommendAll(){
        List<Recommend> recmds = recmdService.loadAll();
        Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("code", 200);
        map.put("rows", recmds);
        return map;
    }

    @RequestMapping("/search")
    @ResponseBody
    public Map<String,Object> searchRecommend(){
    	String ageStr = request.getParameter("age");
		String sexStr = request.getParameter("sex");
		String pageStr = request.getParameter("page");
		String sizeStr = request.getParameter("size");
		if(ageStr==null)
			ageStr = "5";
		if(sexStr==null)
			sexStr = "1";
		if(pageStr==null)
			pageStr = "1";
		if(sizeStr==null)
			sizeStr = "10";
		int age = Integer.valueOf(ageStr);
		int sex = Integer.valueOf(sexStr);
		int page = Integer.valueOf(pageStr);
		int size = Integer.valueOf(sizeStr);
		if(age<0 || age>20)
			age = 5;
		if(sex!=1 && sex!=2)
			sex = 1;
		if(page<1)
			page = 1;
		if(size<10)
			size = 10;
		int offset = Math.max(0, (page-1)) * size;
        List<Recommend> recmds = recmdService.search(age, sex, size, offset);
        Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("code", 200);
        map.put("rows", recmds);
        return map;
    }
    
}